<<<< Programm zur Emulation einer Turingmaschine >>>>
LINK
  write "Simulation einer Turingsmaschine!",lf;
  write "---------------------------------", lf;
  integer "Anzahl der Transitionen = ", TZahl;

DECLARE
<<< Transition: Von Ein Aus Pos Nach >>>>
  array integer Von[1:TZahl] := 0, ..;	-- Ist-Zustand
  array integer Nach[1:TZahl] := 0, ..;	-- Folgezustand
  array character Ein[1:TZahl] := ' ', ..;-- gelesenes Zeichen
  array character Aus[1:TZahl] := ' ', ..;-- Folgezeichen
  array integer Pos[1:TZahl] := 0, ..;	 -- Bewegungsrichtung

  integer Position, Zyklenzahl := 0, Zahl := 15;
  file Eingabe;				-- Datei mit Eingabedaten fr Automaten
  text Band, Band1;			-- Bnder fr Daten und Kopfposition
  integer ZVon;				-- aktueller Zustand
  character ZEin;			-- aktuell gelesenes Zeichen

DO

  open Eingabe to read from "programme/Turing.data";

<<<<<<<<<< Einlesen des Bandes >>>>>>>
  read text from Eingabe Band;		-- liest Text bis vor Kopf
  Position := 11+|Band|;		-- Berechnet Position von Kopf
  read text from Eingabe Band1;		-- liest Text ab Kopf
  Band := "."*10 + Band + Band1 + "."*10; -- erzeugt Ausgabeband
  Band1 := " "*|Band|;			-- Erzeugt das Kopf-Band ("^")

<<<<<<<<<< Einlesen der Transitionen >>>>>>>
  for Lauf := 1 to TZahl 		-- Wiederhole TZahl-mal
      repeat until Von[Lauf]==-1	-- aber nur, falls nach Lesen Von[Lauf]<> 1
  do
    read from Eingabe			-- Lese Transitionen ein
	Von[Lauf],Ein[Lauf],Aus[Lauf],
	Pos[Lauf],Nach[Lauf];
  epilog	-- Berechnet zum Schlu die tatschlich gelesenen Transitionen 
    TZahl "Anzahl der Transitionen" :=
	if Von[Lauf]==-1 then Lauf-1 else Lauf end;
    write "Anzahl der gelesenen Transitionen = " TZahl "." newline;
  done for Lauf;
  
<<<<<<<<<< Berechnung und Ausgabe der aktuellen Zustnde >>>>>>>
  prolog
    ZVon "aktueller Zustand" := Von[1];
    ZEin "aktuelles Zeichen" := Band[Position];

  for MaxDurchlauf to 1000 do	-- Beschrnke Anzahl der Durchlufe

    for Zyklen to Zahl do	-- Ausgabe nur Zahl-mal

    <<<<<<<<<< Ausgabe des aktuellen Zustands auf Monitor >>>>>>>
      write "Band = >" Band "<" newline;
      Band1[Position] "Setze ^ fr Kopf" := '^';
      write "Kopf = >" Band1 
            " : Zustand = " ZVon
            " : Zeichen = " ZEin newline;
      Band1[Position] "Lsche ^ fr Kopf" := ' ';
      
    <<<<<<<<<< Fhre Zustandsbergang durch >>>>>>>>>
      for Lauf := 1 to TZahl do		-- Teste alle Transitionen
	if Von[Lauf]==ZVon and Ein[Lauf]==ZEin then
          Band[Position] := Aus[Lauf];	-- Schreibe neues Zeichen
          Position := Position+Pos[Lauf];-- Berechne neue Posi.
          ZVon := Nach[Lauf];		-- Setze neuen Zustand
	  ZEin := Band[Position];	-- Setze neues Zeichen
	  Zyklenzahl := Zyklenzahl+1;	-- Zhle Anzahl Trans.
	  exit for Lauf;		-- Beende Transition
	end;

      epilog				-- falls keine Transit..
	exit for MaxDurchlauf;		-- ... beende Lauf der TM
      done for Lauf;

    epilog				-- falls keine Transit..
      write "Wie viele Takte weiter gehen? Anzahl = "; read Zahl;
    done for Zyklen;

  done for MaxDurchlauf;

  write "Nach " Zyklenzahl " Zyklen konnte kein Zustand mehr gendert werden." newline;

DONE
